`default_nettype none
module pwm(x, mute, rot, clock, reset, y);
	input wire [3:0] x; // Anders dan bij de buizen-DAC, daarbij had x een teken. Different from valve DAC, there x was signed.
	input wire mute;
	input wire [2:0] rot; // toevalsgetal, 0...7 met elk kans 1/8. random number, 0...7 each with probability 1/8
	input wire clock, reset;
	output wire y;
	reg [3:0] hulp;
	reg [3:0] hulp2;
	reg [2:0] hulp3;
	reg [2:0] rotation;
	reg y_int;
	reg [2:0] count_int;
	always @ (posedge clock)
	begin
		if (reset)
		begin
			count_int <= 0;
			hulp <= 0;
			rotation <= 0;
		end
		else
		begin
			if (count_int == 0)
			begin
				case(mute)
					1'b0:
					begin
						count_int <= 7;
						hulp[3:0] <= x[3:0];
						rotation <= rot;
					end
					1'b1:
					begin
						count_int <= 1; // 01010101... voor stilte, 01010101... for silence
						hulp <= 1;
						rotation <= 0;
					end
				endcase
			end
			else
				count_int <= count_int - 3'b001;
		end
	end
	always @ *
	begin
		hulp2 = count_int + rotation;
		hulp3[2:0] = hulp2[2:0]; // hulp3 = hulp2 mod 8
		if (hulp3 < hulp)
			y_int = 1;
		else
			y_int = 0;
	end
	assign y = y_int;
endmodule
`default_nettype wire
