`default_nettype none
module sigmadeltawrap(x, norot, SevenofNine, mute, sdclock, reset, yl, yr, iclip, scale, nd, rfd);

input wire signed [31:0] x;
input wire norot, SevenofNine, mute;
input wire sdclock, reset;
input wire [1:0] scale;
output reg yl, yr;
output wire iclip;

wire yl_int, yr_int;
wire [32:0] rnd1l;
wire signed [32:0] rnd2l;
wire [32:0] rnd1r;
wire signed [32:0] rnd2r;
wire [32:0] rnd1;
wire signed [32:0] rnd2;
wire [2:0] rotl;
wire [2:0] rotr;
wire [27:0] dummy1;
wire [27:0] dummy2;
wire iclipl, iclipr;
wire sdclock5;
wire signed [34:0] rnd3;
wire signed [34:0] rnd4;

reg signed [26:0] xl;
reg signed [26:0] xr;
reg signed [26:0] xlp;
reg signed [26:0] xrp;

input wire nd;
output wire rfd;
wire rdy, chan_in, chan_out;
wire signed [64:0] dout;

assign rnd1l = rnd1;
assign rnd2l = rnd2;
assign rnd1r = ~rnd1;
assign rnd2r = rnd2;

sigmadelta sdl(xl, norot, SevenofNine, mute, sdclock, sdclock5, reset, rnd1l, rnd2l, rotl, yl_int, iclipl, scale);

sigmadelta sdr(xr, norot, SevenofNine, mute, sdclock, sdclock5, reset, rnd1r, rnd2r, rotr, yr_int, iclipr, scale);

always @ (posedge sdclock)
begin
	yl <= yl_int; // pijpleidingerij, pipelining
	yr <= yr_int;
end

assign iclip = iclipl || iclipr;

xorshiftplus xspl1(sdclock5, reset, {16'h4583, 16'h0000, 16'h2AB7, 16'h0000}, {rnd1, rotr, dummy1});
xorshiftplus xspl2(sdclock5, reset, {32'h93205FF3, 32'h00000000}, {rnd2, rotl, dummy2});

	wire CLK0, CLK180, CLK270, CLK2X, CLK2X180, CLK90, CLKDV, firclock180, LOCKED, PSDONE, CLKFB;
	wire [7:0] STATUS;
	//klokken maken, making clocks
	DCM_SP #(.CLKDV_DIVIDE(3.0), //Afgedeelde uitgang is gerelateerd aan fin en is dus onbruikbaar.
		.CLKFX_DIVIDE(1),
		.CLKFX_MULTIPLY(5),
		.CLKIN_DIVIDE_BY_2("FALSE"),
		.CLKIN_PERIOD(40),
		.CLKOUT_PHASE_SHIFT("FIXED"),
		.CLK_FEEDBACK("1X"), //????
		.DESKEW_ADJUST("SYSTEM_SYNCHRONOUS"), //????
		.DFS_FREQUENCY_MODE("LOW"),
		.DLL_FREQUENCY_MODE("LOW"),
		.DSS_MODE("NONE"),
		.DUTY_CYCLE_CORRECTION("TRUE"),
		.FACTORY_JF(16'hc080),
		.PHASE_SHIFT(0), // 0/256 times input clock period
		.STARTUP_WAIT("FALSE"))
		DCM_SP_inst (CLK0, CLK180, CLK270, CLK2X, CLK2X180, CLK90, CLKDV, sdclock5, firclock180, LOCKED, PSDONE, STATUS, CLK0, sdclock, 1'b0, 1'b0, 1'b0, 1'b0, reset);
		// CLKFB op CLK0 aansluiten is eigenlijk niet eens nodig als je alleen CLKFX maar gebruikt.
		// Connecting CLKFB to CLK0 is actually not even needed when you only use CLKFX.

		// Later overschakelen op een PLL in plaats van een DLL? Maatregelen voor goed opstarten en heropstarten als vergrendeling foutgaat?

interpol8 interpolator (
	.clk(sdclock5), // input clk
	.ce(1'b1), // input ce
	.nd(nd), // input nd
	.rfd(rfd), // output rfd
	.rdy(rdy), // output rdy
	.chan_in(chan_in), // output [0 : 0] chan_in
	.chan_out(chan_out), // output [0 : 0] chan_out
	.din(x), // input [31 : 0] din
	.dout(dout)); // output [61 : 0] dout

xorshiftplus xspl3(sdclock5, reset, {16'h4583, 16'hF65E, 16'h2AB7, 16'h8877}, {rnd3[34], rnd4[34], rnd3[33], rnd4[33], rnd3[32], rnd4[32], rnd3[31], rnd4[31], rnd3[30], rnd4[30], rnd3[29], rnd4[29], rnd3[28], rnd4[28], rnd3[27:3], rnd4[27:3]}); 
assign rnd3[2:0] = dummy1[27:25];
assign rnd4[2:0] = dummy2[27:25];

always @ (posedge sdclock5)
begin
	if ((chan_out == 1'b1) && (rdy == 1'b1)) xlp <= ((dout + rnd3 + rnd4) >>> 35);
	if ((chan_out == 1'b0) && (rdy == 1'b1)) xrp <= ((dout + rnd3 + rnd4) >>> 35);
	// Klopt natuurlijk geen hout van!
	xl <= xlp;
	xr <= xrp;
end

endmodule
`default_nettype wire
